function constraints_cu = constraints
allsyms

ETA_cu     = ETA   *epsp_ba1;
ETA_cup    = ETA   *epsp_ba1p;

ETATIL_cu  = ETATIL*epsw_ba1;
ETATIL_cup = ETATIL*epsw_ba1p;

muI_cu  = muups_ba1*muzstar_cu;
muI_cup = muups_ba1p*muzstar_cup;
MUI     = MUUPS*MUZSTAR;

pf_cu  = (u_cu*k_ba1/muI_cu)^THETA * h_cu^(1-THETA) - PSSI;

delta_cu  = DELTA + GAMAI * (u_cu-U)  + GAMAII/2 * (u_cu-U)^2;
delta_cup = DELTA + GAMAI * (u_cup-U) + GAMAII/2 * (u_cup-U)^2;

rk_cu  = qq_cu*diff(delta_cu, 'u_cu' )/(1-tau_cu);
rk_cup = qq_cup*diff(delta_cup,'u_cup')/(1-tau_cup);

% qk_cu    = k_ba1* KAPA /2 * (k_cu/k_ba1*muI_cu  - MUI)^2;
% qk_cup   = k_cu * KAPA /2 * (k_cup/k_cu*muI_cup - MUI)^2;
% d1qk_cu  = diff(qk_cu,'k_cu');  
% d2qk_cup = diff(qk_cup,'k_cu'); 

qiv      = iv_cu  * (1 - KAPA /2 * (iv_cu/iv_ba1 * muI_cu  - MUI)^2);
qivp     = iv_cup * (1 - KAPA /2 * ( iv_cup/iv_cu* muI_cup - MUI)^2);
d1qiv    = diff(qiv, iv_cu);
d2qivp   = diff(qivp,iv_cu);

%mc_cu  = rk_cu  / THETA /  (u_cu*k_ba1 / h_cu /muI_cu )^(THETA-1);
%mc_cup = rk_cup / THETA /  (u_cup*k_cu / h_cup/muI_cup)^(THETA-1);

% util_cu  = d_ba1 *(log(c_cu  - BC*cs_ba1/muzstar_cu ) - h_cu^(1+SSIGMA)/(1+SSIGMA));
% util_cup = d_ba1p*(log(c_cup - BC*cs_cu/muzstar_cup ) - h_cup^(1+SSIGMA)/(1+SSIGMA));

% util_cu  = d_ba1 *(c_cu  - BC*cs_ba1/muzstar_cu )^(1-SSIGMA)/(1-SSIGMA)*h_cu^(ZZETA+1) ;
% util_cup = d_ba1p*(c_cup - BC*cs_cu/muzstar_cup )^(1-SSIGMA)/(1-SSIGMA)*h_cup^(ZZETA+1);

util_cu  = d_ba1 *(c_cu  - BC*cs_ba1/muzstar_cu )^(1-SSIGMA)/(1-SSIGMA)*(1-h_cu)^(ZZETA) ;
util_cup = d_ba1p*(c_cup - BC*cs_cu/muzstar_cup )^(1-SSIGMA)/(1-SSIGMA)*(1-h_cup)^(ZZETA);

la_cu     = diff(util_cu, 'c_cu'  );
la_cup    = diff(util_cup,'c_cup' );

wac_cu  = ALFATIL/2 *(w_cu/ w_ba1*muzstar_cu*pai_cu - MUZSTAR*PAI)^2;
wac_cup = ALFATIL/2 *(w_cup/w_cu*muzstar_cup*pai_cup - MUZSTAR*PAI)^2;

pac_cu  = ALFA/2 *(pai_cu  - PAI)^2;
pac_cup = ALFA/2 *(pai_cup - PAI)^2;

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
xc_cu  =  c_cu - BC* cs_ba1/muzstar_cu;
xg_cu  =  g_cu - BG* gs_ba1/muzstar_cu;
%xi_cu  =  iv_cu + wac_cu*w_cu*h_cu ;% + qk_cu;
%nutili_cu = 1 - mc_cu;
a_cu = c_cu + g_cu + w_cu*h_cu*wac_cu + iv_cu ;%+ qk_cu;

BETTA = BETTA*muzstar_cup^(1-SSIGMA);
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
constraints_cu = [];
constraints_cu = [ constraints_cu;   -mc_cu + rk_cu  / THETA /  (u_cu*k_ba1 / h_cu /muI_cu )^(THETA-1)];
constraints_cu = [ constraints_cu;   -k_cu + (1-delta_cu) * k_ba1/muI_cu + qiv ];
constraints_cu = [ constraints_cu;    w_cu*(1 - tau_cu -wac_cu)*la_cu + diff(util_cu, 'h_cu')*mutil_cu];
%constraints_cu = [ constraints_cu;  -(1 + d1qk_cu) + BETTA *la_cup/la_cu/muI_cup * ( u_cup*rk_cup + (1-delta_cup) - d2qk_cup )];
constraints_cu = [ constraints_cu; - qq_cu + BETTA*la_cup/la_cu/muI_cup*((1-tau_cup)* u_cup*rk_cup + qq_cup*(1-delta_cup) )];
constraints_cu = [ constraints_cu; - 1 + qq_cu * d1qiv + BETTA * la_cup/la_cu/muI_cup * qq_cup * d2qivp];
constraints_cu = [ constraints_cu;  - 1 + BETTA *r_cu * la_cup/la_cu/muzstar_cup / pai_cup];
%constraints_cu = [ constraints_cu;  - 1 + BETTA *r_cu * la_cup/la_cu/muzstar_cup / pai_cup];
%%e5_cu = (1-ETATIL)*h_cu *(1-wac_cu)- diff(wac_cu,'w_cu')*w_cu*h_cu + ETATIL*h_cu/mutil_cu - BETTA * la_cup/la_cu*diff(wac_cup,'w_cu')*w_cup*h_cup;
constraints_cu = [ constraints_cu;  - diff(wac_cu,'w_cu')*w_cu + (1-ETATIL_cu)*(1-tau_cu - wac_cu) + ETATIL_cu/mutil_cu - BETTA*la_cup/la_cu*h_cup/h_cu*diff(wac_cup,'w_cu')*w_cup];
constraints_cu = [ constraints_cu;  -pf_cu + a_cu];
constraints_cu = [ constraints_cu;  -mc_cu + w_cu / diff(pf_cu,'h_cu')];
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
constraints_cu = [ constraints_cu;   (1-ETA_cu+ETA_cu*mc_cu)*a_cu - ETA_cu * ( cnutil_cu*xc_cu + gnutil_cu * xg_cu - (1-mc_cu)*(c_cu + g_cu) )- ...
pai_cu*diff(pac_cu,'pai_cu') + BETTA*la_cup/la_cu*pai_cup*diff(pac_cup,'pai_cup')];
constraints_cu = [ constraints_cu;  -(cnutil_cu + mc_cu - 1) + BETTA*la_cup/la_cu /muzstar_cup * ((1-RHOC)*BC * cnutil_cup  + RHOC*( cnutil_cup + mc_cup - 1))];
constraints_cu = [ constraints_cu;  -(gnutil_cu + mc_cu - 1) + BETTA*la_cup/la_cu /muzstar_cup * ((1-RHOGG)*BG * gnutil_cup  + RHOGG*( gnutil_cup + mc_cup - 1))];
% constraints_cu = [ constraints_cu;  -(cnutil_cu + mc_cu - 1) + BETTA*la_cup/la_cu /muzstar_cup * ((1-RHOC)*BC * cnutil_cup  + RHOC*( cnutil_cup + mc_cup - 1))];
% constraints_cu = [ constraints_cu;  -(gnutil_cu + mc_cu - 1) + BETTA*la_cup/la_cu /muzstar_cup * ((1-RHOG)*BG * gnutil_cup  + RHOG*( gnutil_cup + mc_cup - 1))];
constraints_cu = [ constraints_cu;  - cs_cu + RHOC*cs_ba1/muzstar_cu + (1-RHOC)*c_cu ];
constraints_cu = [ constraints_cu;  - gs_cu + RHOGG*gs_ba1/muzstar_cu + (1-RHOGG)*g_cu];
%constraints_cu = [ constraints_cu;  - xx_cu + (c_cu  - BC*cs_ba1/muzstar_cu)^GAMA*xx_ba1^(1-GAMA) ];
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
constraints_cu = [ constraints_cu;  - output_cu   + pf_cu - pac_cu ];
constraints_cu = [ constraints_cu;  - log(r_cu/R) + ALFA_R*log(r_ba1/R)+ALFA_PAI*log(pai_cu/PAI) + ALFA_Y*log(output_cu/output_ba1*muzstar_cu/MUZSTAR) + log(mur_ba1/MUR) ];
constraints_cu = [ constraints_cu;  - muzstar_cu  + muups_ba1^(THETA/(1-THETA))*muz_ba1 ];
%constraints_cu = [constraints_cu;   - epsg_ba1    + g_cu/output_cu];
constraints_cu = [constraints_cu;   - epsg_ba1    + g_cu*muzstar_cu/output_ba1];
constraints_cu = [constraints_cu; - muc_cu    +  c_cu*muzstar_cu/c_ba1];
constraints_cu = [constraints_cu; - muiv_cu   +  iv_cu*muI_cu/iv_ba1];
constraints_cu = [constraints_cu; - muw_cu    +  w_cu*muzstar_cu/w_ba1];
%constraints_cu = [constraints_cu;   - epsg_ba1    + g_cu/output_ba1];
%constraints_cu = [constraints_cu;   - epsg_ba1    + g_cu];%*muzstar_cu/output_ba1];
constraints_cu = [constraints_cu;   - log(tau_cu/TAU) + ALFA_tau*log(tau_ba1/TAU) + ALFA_tauy*log(output_ba1/OUTPUT) + log(epstau_ba1/EPSTAU)];
constraints_cu = [ constraints_cu;  - log(epsg_ba1p/EPSG)     + RHOG    * log(epsg_ba1/EPSG)    ];
constraints_cu = [ constraints_cu;  - log(muups_ba1p/MUUPS)   + RHOMUUPS* log(muups_ba1/MUUPS)  ];
constraints_cu = [ constraints_cu;  - log(muz_ba1p/MUZ)       + RHOMUZ  * log(muz_ba1/MUZ)      ];
constraints_cu = [ constraints_cu;  - log(d_ba1p/D)           + RHOPREF * log(d_ba1/D)          ];
constraints_cu = [ constraints_cu;  - log(mur_ba1p/MUR)       + RHOR    * log(mur_ba1/MUR)      ];
constraints_cu = [ constraints_cu;  - log(epsw_ba1p/EPSW)     + RHOw    * log(epsw_ba1/EPSW) + log(upsw_ba1p/UPSW) - MUw*log(upsw_ba1/UPSW) ];
constraints_cu = [ constraints_cu;  - log(epsp_ba1p/EPSP)     + RHOp    * log(epsp_ba1/EPSP) + log(upsp_ba1p/UPSP) - MUp*log(upsp_ba1/UPSP)];
constraints_cu = [ constraints_cu;  - log(epstau_ba1p/EPSTAU) + RHOtau  * log(epstau_ba1/EPSTAU)];
constraints_cu = [ constraints_cu;  - log(upsp_ba1p/UPSP) + RHOupsP  * log(upsp_ba1/UPSP)];
constraints_cu = [ constraints_cu;  - log(upsw_ba1p/UPSW) + RHOupsW  * log(upsw_ba1/UPSW)];