function lnpy = objfcnmh(para,yyyy,xxyy,xxxx, f,fx, fy, fxp, fyp,statevar_cu,controlvar_cu);

global bounds nvar  para_mask cointadd nobs lambda

nobsc = nobs + lambda;    
k     = size(xxxx,1);

[yyyyd,xxyyd,xxxxd, ZZ] = varprio(para,f,fx, fy, fxp, fyp,statevar_cu,controlvar_cu);

if (yyyyd == 0)
    disp('Warning: yyyyd = 0 in objfcnmh')
    lnpy = -1E10;	lnpost = -1E6;
    return
end

    yyyyc = (yyyy + lambda*yyyyd)/nobsc;
%    xxyyc = (LAMinv*xxyy + lambda*xxyyd)/nobsc;
%   xxxxc = (LAMinv*xxxx*LAMinv + lambda*xxxxd)/nobsc;
   xxyyc = (xxyy + lambda*xxyyd)/nobsc;
   xxxxc = (xxxx + lambda*xxxxd)/nobsc;

   %Compute OLS estimates
   %Sig_hat = (yyyyc - xxyyc'*( xxxxc \ xxyyc ))/nobsc; 
    Sig_hat = (yyyyc - xxyyc'*( xxxxc \ xxyyc )); 
    Sig_hatd = yyyyd - xxyyd'*( xxxxd \ xxyyd );    
    
    lnkapt = (-nvar*(nobs)/2)*log(2*pi) + ((nobs)*nvar/2)*log(2);
    for i = 1:nvar
        lnkapt = lnkapt+gammaln((nobsc-k+1-i)/2)-gammaln((lambda-k+1-i)/2);
    end
    lnpy  = lnkapt  - ((nobsc-k)/2)*log(det(nobsc*Sig_hat)) + ((lambda-k)/2)*log(det(lambda*Sig_hatd)) ...
          - (nvar/2)*log(det(nobsc*xxxxc)/det(lambda*xxxxd));
        
    %[(det(nobsc*Sig_hat)) det(lambda*Sig_hatd)      det(nobsc*xxxxc)/det(lambda*xxxxd)]
%     lnpy  = lnkapt  - ((nobsc-k)/2)*(nvar*log(nobsc)+log(det(Sig_hat))) + ((lambda-k)/2)*(nvar*log(lambda) + log(det(Sig_hatd))) ...
%           - (nvar/2)*( k*log(nobsc) + log(det(xxxxc)) - k*log(lambda)- log(det(xxxxd)))
%   lnpy  = lnkapt  - ((nobsc-k)/2)*log(det(nobsc*Sig_hat)) + ((lambda-k)/2)*log(det(lambda*Sig_hatd)) ...
%          - (nvar/2)*log(det(xxxxc)/det(lambda*xxxxd));
%	lnprio  = priodens(para);%,pmean,pstdd,pshape);
%	lnpost  = lnpy + lnprio;
    if abs(imag(lnpy))>1.0e-10
        isp('note abs(imag(lnpy))>1.0e-10 in objfcnmh')
        lnpost = -1E6;
        lnpy   = -1E20;
        return
    end
%end
%save obj_res.mat 