function IRF = IRFwbands(y,f,fx,fy,fxp,fyp,statevar_cu, controlvar_cu)

sg      = find( statevar_cu == 'epsg_ba1'   );
ng      = find(controlvar_cu == 'g_cu'      );
nr      = find(controlvar_cu == 'r_cu'     );
ni      = find(controlvar_cu == 'iv_cu'    );
nc      = find(controlvar_cu == 'c_cu'     );
npi     = find(controlvar_cu == 'pai_cu'   );
nw      = find(controlvar_cu == 'w_cu'     );
nh      = find(controlvar_cu == 'h_cu'     );
noutput = find(controlvar_cu == 'output_cu');
ntau    = find(controlvar_cu == 'tau_cu'   );

IRFtime = 20;
sizex = size(fx,2);
IR = zeros(IRFtime,sizex);

ran   = randi([ 1 length(y)],1,100);

for b = 1:length(ran)
    b
    Theta = y(ran(b),:);
    [ gx, hx, exitflag ] = deep_run(Theta, f, fx, fy, fxp, fyp);
    if (exitflag ~= 1)
        exitflag
       % b
       %Theta' 
    end
    x0 = zeros(sizex,1);
    x0(sg) = Theta(end-7);
    for j = 1:IRFtime
        IR(j,:) = x0';
        x0 = hx*x0;
    end
    %gxz = gx( [ng ntau nc ni nh nw npi nr], : );
    %gxz( 7:8, : ) = 4*gxz( 7:8, : );
    gxz = gx([nc noutput],:);
    IRFth(:,:,b) = IR*gxz';
end
nvar = size(gxz,1);
% for l = 1:IRFtime
%     for j = 1:nvar
%         IRF(l,j,1:3) = prctile(squeeze(IRFth(l,j,:)),[5 50 95]);
%     end
% end
IRF = prctile(IRFth,[5 50 95],3);
%save IRFs.mat IRF IRFth