clear all 
%close all 
clc
restoredefaultpath
addpath C:\Users\Anna\Dropbox\Research\GOVSP1\MODEL
% addpath C:\Users\Anna\Dropbox\Research\GOVSP1\BL
%addpath C:\Users\Anna\Dropbox\Research\GOVSP1\fortran\Bayesian\2015_0530\BL
addpath C:\Users\Anna\Dropbox\Research\GOVSP1\NES
%addpath C:\Users\Anna\Dropbox\Research\GOVSP1\fortran\Bayesian\2015_0530\NES\4\

IRFtime  =20;
t = [1:1:IRFtime];
[f, fx, fy, fxp, fyp, statevar_cu,statevar_cup,controlvar_cu,controlvar_cup] = competitive_eqm;
    
sg      = find( statevar_cu == 'epsg_ba1'  );
ng      = find(controlvar_cu == 'g_cu'     );
nr      = find(controlvar_cu == 'r_cu'     );
ni      = find(controlvar_cu == 'iv_cu'    );
nc      = find(controlvar_cu == 'c_cu'     );
npi     = find(controlvar_cu == 'pai_cu'   );
nw      = find(controlvar_cu == 'w_cu'     );
nh      = find(controlvar_cu == 'h_cu'     );
noutput = find(controlvar_cu == 'output_cu');
ntau    = find(controlvar_cu == 'tau_cu'   );
sizex = size(fx,2);
load C:\Users\Anna\Dropbox\Research\GOVSP1\fortran\Bayesian\2015_0530\NES\6\mean_est.txt
%load C:\Users\Anna\Dropbox\Research\GOVSP1\fortran\Bayesian\2015_0530\MIX\1\mean_est.txt
%load C:\Users\Anna\Dropbox\Research\GOVSP1\fortran\Bayesian\2015_0530\BL\mean_est.txt
load C:\Users\Anna\Dropbox\Research\GSP\NES\mean_est.txt
% 
% Theta = zeros(1:35,1);
% Theta([1 10:35]) = mean_est;
%Theta([1 6:35]) = mean_est;
Theta = mean_est;
%addpath C:\Users\Anna\Dropbox\Research\GOVSP1\fortran\2015_0602\NES\4\LA04
%load C:\Users\Anna\Dropbox\Research\GOVSP1\fortran\2015_0602\NES\4\LA04\mean_est.txt
% y=[];
% num_theta = 35;
% for i = 1:num_theta
%     eval(['load x',num2str(i),'_NES.txt' ])
%     eval(['hlp = x', num2str(i), '_NES;' ])
%     y = [y   hlp];
% end
%Theta = mean_est;%y(1,:);
[ gx, hx, exitflag ] = deep_run(Theta, f, fx, fy, fxp, fyp);
x0 = zeros(sizex,1);
x0(sg) = Theta(end-7);
for j = 1:IRFtime
    IR(j,:) = x0';
    x0 = hx*x0;
end
gxz = gx( [ng ntau nc ni nh nw npi nr], : );
gxz( 7:8, : ) = 4*gxz( 7:8, : );
IRFth = IR*gxz';
figure
for i = 1:8
    subplot(4,2,i)
    plot(t,100*IRFth(:,i))
    hold on
%    axis([1 20 -0.15 0.05])
%axis tight
end

return
id = char('NES')
y=[];
    num_theta = 27;
    for i = 1:num_theta
        eval(['load x',num2str(i),'_BL.txt' ])
        eval(['hlp = x', num2str(i), '_BL;' ])
        y = [y   hlp];
    end

ran   = randi([ 1 length(y)],1,10);
IrFth = [];
for b = 1:length(ran)
    b
    Theta = y(ran(b),:);
    [ gx, hx, exitflag ] = deep_run(Theta, f, fx, fy, fxp, fyp);
    if (exitflag ~= 1)
        exitflag
    end
    x0 = zeros(sizex,1);
    x0(sg) = Theta(end-7);
    for j = 1:IRFtime
        IR(j,:) = x0';
        x0 = hx*x0;
    end
%    gxz = gx([nc noutput],:);
    IRFth(:,:,b) = IR*gxz';
end
nvar = size(gxz,1);
IRF = prctile(IRFth,[5 50 95],3);


for i = 1:8
    subplot(4,2,i)
    plot(t,100*squeeze(IRF(:,i,:)))
    hold on
%    axis([1 20 -0.15 0.05])
%axis tight
end
