function [ loglikepri, loglike, logpri, max_loglikepri,  Theta, mu, sigma, prec ] = loglikepri(spath, id)

eval([ 'load ', spath,'xLower'     id,'.txt']);
eval(['xLower = xLower',id,';'])
eval([ 'load ', spath,'xUpper',    id,'.txt']);
eval(['xUpper = xUpper',id,';'])
eval([ 'load ', spath,'xPar1',     id,'.txt']);
eval(['xPar1 = xPar1',id,';'])
eval([ 'load ', spath,'xPar2',     id,'.txt']);
eval(['xPar2 = xPar2',id,';'])
eval([ 'load ', spath,'xv_beta',   id,'.txt']);
eval(['xv_beta = xv_beta',id,';'])
eval(['load ', spath,'xv_normal', id,'.txt']);
eval(['xv_normal = xv_normal',id,';'])
eval(['load ', spath,'xv_gama',   id,'.txt']);
eval(['xv_gama = xv_gama',id,';'])
eval(['load ', spath,'xv_uniform',id,'.txt']);
eval(['xv_uniform = xv_uniform',id,';'])
eval(['load ', spath,'xv_igama',  id,'.txt']);
eval(['xv_igama = xv_igama',id,';'])
eval(['load ', spath,'xDist',     id,'.txt']);
eval(['xDist = xDist',id,';'])
num_Theta = eval(['size(xPar1',id,');']);

Theta = [];
for i = 1:num_Theta
    eval(['load ',spath,'x',num2str(i),id,'.txt' ])
    eval(['hlp = x', num2str(i), id,';' ])
    Theta = [Theta hlp];
end

start  = ceil(0.3*length(xDist));
finish = ceil(1.0*length(xDist));

loglike = xDist;
loglike = loglike(start:finish);
Theta   = Theta(start:finish,:);

logpri  = prior(Theta,xUpper,xLower,xPar1,xPar2,xv_uniform,xv_normal,xv_beta,xv_gama,xv_igama);

mu    = mean(Theta);
sigma = cov(Theta);
prec  = inv(sigma);

maxloglike     = max(loglike)
loglikepri     = loglike + logpri;
max_loglikepri = max(loglikepri);