function logmarginal = logmarg(Theta,likepri,sigma,mu,prec)

index = 1;
geweke = zeros(length(Theta),1);
for p = 0.1:0.1:0.9;    
    chi = chi2inv(1-p,size(Theta,2));
    marginalcon = ((2*pi)^(-.5*size(Theta,2))*det(sigma)^(-.5))/p;
    j = 0;
    for i = 1:size(Theta,1)
        %calculating geweke function
        %geweke(i,1) = fgeweke(Theta(i,:),mu,prec,chi,marginalcon);
        geweke(i,1) = fgeweke(Theta(i,:),mu,prec,chi);
        if geweke(i)>0
            j = j + 1;
        end
    end
    %geweke
    bad(index) = j/size(Theta,1);% - j;
    geweke = geweke./likepri;
    %meanGEWEKE = mean(geweke);
    %harmonic mean
    %marginal1 = 1/mean(geweke)
    %marginal1 = 1/mean(geweke);    
    % log marginal likelihood
    logmarginal(index) = - log(mean(geweke)) - log(marginalcon);
    index = index + 1;
end