clear all
close all
clc

restoredefaultpath
%addpath C:\Users\31049308\Dropbox\Research\GOVSP1\MODEL
addpath C:\Users\anutako\Dropbox\Research\GOVSP1\MODEL
%addpath C:\Users\31049308\Dropbox\Research\GOVSP1\fortran\BL\LA03

%addpath C:\Users\31049308\Dropbox\Research\GOVSP1\fortran\2015_0420\BL\LA03
%addpath C:\Users\anutako\Dropbox\Research\GOVSP1\fortran\2015_0420\BL\LA03
addpath C:\Users\anutako\Dropbox\Research\GOVSP1\fortran\2015_0521\BL\LA03
global nvar nlags ncoint nconst Pmean

varspec();

load mean_est.txt

[f, fx, fy, fxp, fyp, statevar_cu,statevar_cup,controlvar_cu,controlvar_cup] = competitive_eqm;

smuz    = find( statevar_cu == 'muz_ba1'    );
smuups  = find( statevar_cu == 'muups_ba1'  );
sd      = find( statevar_cu == 'd_ba1'      );
sg      = find( statevar_cu == 'epsg_ba1'   );
sr      = find( statevar_cu == 'mur_ba1'    );
stau    = find( statevar_cu == 'epstau_ba1' );
sp      = find( statevar_cu == 'upsp_ba1'   );
sw      = find( statevar_cu == 'upsw_ba1'   );
ng      = find(controlvar_cu == 'g_cu'      );
nr      = find(controlvar_cu == 'r_cu'     );
ni      = find(controlvar_cu == 'iv_cu'    );
nc      = find(controlvar_cu == 'c_cu'     );
npi     = find(controlvar_cu == 'pai_cu'   );
nw      = find(controlvar_cu == 'w_cu'     );
nh      = find(controlvar_cu == 'h_cu'     );
noutput = find(controlvar_cu == 'output_cu');
ntau    = find(controlvar_cu == 'tau_cu'   );

IRFtime= 16;
count_explode = 0;
Theta = mean_est;
Theta = Pmean;
[ gx, hx, exitflag ] = deep_run(Theta, f, fx, fy, fxp, fyp, statevar_cu, controlvar_cu);

sizex = length(statevar_cu);
sizey = length(controlvar_cu);

[yyyyd,xxyyd,xxxxd, ZZ,gxt] = varprio(Theta,f,fx, fy, fxp, fyp,statevar_cu,controlvar_cu);
%[yyyyd1,xxyyd1,xxxxd1, ZZ1] = varprio_dn(Theta,f,fx, fy, fxp, fyp,statevar_cu,controlvar_cu);
%return
PHI = ( xxxxd \ xxyyd );
Sig_hat = yyyyd - xxyyd'*PHI;
SIGu = Sig_hat;%*nobsc/(nobsc-k-nvar);% iwishrnd(Sig_hat*nobsc,nobsc-k);
Sig   = chol(SIGu,'lower');

%B = zeros(nvar*nlags+nvar);
PHIu = PHI;
%B(1:nvar,:) = PHIu(1+nconst+ncoint:end,:)'
if nlags > 1
   eye(nvar*nlags);
   B = [ PHIu(1+nconst+ncoint:end,:)'; ans(1:nvar*(nlags-1),:) ];
else
   B = PHIu(1+nconst+ncoint:end,:)';
end
var_explode = sum(abs(eig(B))>1);
if var_explode > 0
   warning('VAR Explosive')
   %count_explode = count_explode + 1;
end
% Identify shock

STD_EPSG     = Theta(end-7);
STD_EPSMUZ   = Theta(end-6);
STD_EPSMUUPS = Theta(end-5);
STD_EPSD     = Theta(end-4);
STD_EPSP     = Theta(end-3);
STD_EPSW     = Theta(end-2);
STD_EPSR     = Theta(end-1);
STD_EPStau   = Theta(end);

shocks = zeros(nvar,nvar);
shocks(1,1) = STD_EPSG;     % G/Y
shocks(2,2) = STD_EPStau;   % TAU
shocks(3,3) = STD_EPSMUZ;   % C
shocks(4,4) = STD_EPSMUUPS; % I
shocks(5,5) = STD_EPSD;     % H
shocks(6,6) = STD_EPSW;     % W
shocks(7,7) = STD_EPSP;     % PAI
shocks(8,8) = STD_EPSR;     % R

vectr = [ sg stau smuz smuups sd sw sp sr ];
A0        = gxt(:,vectr)*shocks;%
[q r]     = qr(A0');
Sigstar   = r';
Omegastar = q';
%% Normalize matrices (change row signs) so that the lower diagonal matrix Sigstar 
%% has positive diagonal elements  
Sigstar   = repmat(sign(diag(r)),[1 nvar]).*Sigstar;
Omegastar = repmat(sign(diag(r)),[1 nvar]).*Omegastar;

IRFid = Sig*Omegastar;

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% cc_dy   = eye(nvar*nlags);
% cc_y    = eye(nvar*nlags);
% msel    = [eye(nvar) ; zeros((nlags-1)*nvar,nvar)];
% %bbirf    = zeros(IRFtime,nvar^2);
% bbirf    = zeros(IRFtime,nvar,nvar);
% out         = msel'*cc_dy*msel*IRFid;
% %bbirf(1,:)  = out(:)';
% bbirf(1,:,:)  = out;
% 
% for t = 2:IRFtime;                 
%   cc_dy = B*cc_dy;
% %   if coint
% %     cc_dy = cc_dy+(cc_cointtilde*cointvec*msel')*cc_y;
% %     cc_y  = cc_y + cc_dy;
% %   end
%   out = msel'*cc_dy*msel*IRFid;
%  % bbirf(t,:)    = out(:)';  
%   bbirf(t,:,:)    = out;  
% end
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
names = char('G','\tau','C','I','h','W','\pi','R');
%for k = 1:1%nvar 
k = 1;
shock = zeros(nvar,1);
shock(k)= 1;
IR = zeros(IRFtime,nvar);
for j = 1 : IRFtime
     B^(j-1);
     IR(j,:) = ans(1:nvar,1:nvar)*IRFid*shock;
end
IRF_i = IR;
IRF_i(:,[1, 3, 4, 6]) = cumsum(IRF_i(:,[1, 3, 4, 6])); 
RESPONSES(:,:,k) = IRF_i; 

% for l = 1:IRFtime
%     for j = 1:nvar
%         RESPONSES(l,j,:) = prctile(IRF_i(l,j,:),[5 50 95]);
%     end
% end

IR = zeros(IRFtime,sizex);
x0 = zeros(sizex,1);
x0(vectr(k)) = shocks(k,k);
%names = char('G','\tau','C','I','h','W','\pi','R');
%IR0 = zeros(4,1);
%IR0 = gx([ ng nc  ni nw ],:)*x0;
for j = 1:IRFtime
    IR(j,:) = x0';
    x0 = hx*x0;
end
gxz = gx( [ng ntau nc ni nh nw npi nr], : );
gxz( 7:8, : ) = 4*gxz( 7:8, : );
IRFgrowth(:,:,k) = IR*gxz';
%IRFgrowth(:,[7,8],k) = 4*IRFgrowth(:,[7,8],k);
%IRFgrowth(:,[1 3 4 6],k) = [ 0 0 0 0 ; cumsum(IRFgrowth(1:end-1,[1 3 4 6],k))] + kron(ones(IRFtime,1),IR0');
%end
%RESPONSES(:,[1 3 4 6],k) = [ 0 0 0 0 ; (RESPONSES(1:end-1,[1 3 4 6],k))]+ kron(ones(IRFtime,1),IR0'); 
names_shocks = {'G'; 'Tax';'Tech';'Inv';'d';'W';'p';'Money'};

% figure
% for k = 1:nvar
%     for i = 1:nvar
%        subplot(nvar,nvar, (k-1)*nvar + i)
%          plot([1:1:IRFtime], 100*RESPONSES(:,i,k), 'LineStyle','--','Color',[0 0 0])
%     %    plot([1:1:IRFtime], RESPONSES(:,i,1), 'LineStyle','--','Color',[0 0 0])
%     %    hold on
%     %    plot([1:1:IRFtime], RESPONSES(:,i,2), 'LineStyle','--','Color',[0 0 0])
%     %    hold on
%     %    plot([1:1:IRFtime], RESPONSES(:,i,3), 'LineStyle','--','Color',[0 0 0])
%     %    title(names(i,:))
%         hold on
%        plot([1:1:IRFtime], 100*IRFgrowth(:,i,k))
%        axis tight
%        if (i == 1)
%                ylabel(names_shocks(k))
%        end
%        if (k == nvar)
%        xlabel(names(i,:))
%        end
%     end
% end
figure
for i = 1:nvar
   subplot(4,2,  i)
%    plot([1:1:IRFtime], RESPONSES(:,i,1), 'LineStyle','--','Color',[0 0 0])
%   hold on
  plot([1:1:IRFtime], IRFgrowth(:,i,1))
   axis tight
   title(names(i,:))
end
figure
for i = 1:nvar
   subplot(4,2,  i)
   plot([1:1:IRFtime], RESPONSES(:,i,1), 'LineStyle','--','Color',[0 0 0])
  hold on
  plot([1:1:IRFtime], IRFgrowth(:,i,1))
   axis tight
   title(names(i,:))
end

return
% check simple cholesky identification 
shock = zeros(nvar,1);
shock(1)= 1;
IR = zeros(IRFtime,nvar);
for j = 1 : IRFtime
     B^(j-1);
     IR1(j,:) = ans(1:nvar,1:nvar)*Sig*shock;
     %IR2(j,:) = ans(1:nvar,1:nvar)*Sig*Omegastar*shock;
end
IRF_i = IR1;
RESPONSESu1(:,:) = IRF_i; 
%IRF_i = IR2;
%RESPONSESu2(:,:) = IRF_i; 
figure
for i = 1:nvar
   subplot(4,2,i)
   plot([1:1:IRFtime], RESPONSESu1(:,i), 'LineStyle','--','Color',[0 0 0])
   hold on
%    plot([1:1:IRFtime], RESPONSESu2(:,i))
%    axis tight
   title(names(i,:))
end