clear all
clc
close all

restoredefaultpath
addpath C:\Users\Anna\Dropbox\Research\GOVSP1\IRFs\
addpath C:\Users\Anna\Dropbox\Research\GOVSP1\MODEL\

path_BL   = char('C:\Users\Anna\Dropbox\Research\GOVSP1\fortran\2015_0601\BL\LA04\'  );
path_DH   = char('C:\Users\Anna\Dropbox\Research\GOVSP1\fortran\2015_0601\DH\LA04\'  );
path_PROD = char('C:\Users\Anna\Dropbox\Research\GOVSP1\fortran\2015_0601\PROD\LA04\');
path_ROT  = char('C:\Users\Anna\Dropbox\Research\GOVSP1\fortran\2015_0601\ROT\LA04\' );
path_UTIL = char('C:\Users\Anna\Dropbox\Research\GOVSP1\fortran\2015_0601\UTIL\LA04\'); 

IRFtime = 20;
t = [1:1:IRFtime];
figure
disp('DH')
subplot(2,3,1)
addpath C:\Users\Anna\Dropbox\Research\GOVSP1\DH
eval(['addpath ',path_DH])

y = [];
num_theta = 30;
for i = 1:num_theta
    eval(['load x',num2str(i),'_DH.txt' ])
    eval(['hlp = x', num2str(i), '_DH;' ])
    y = [y   hlp];
end
[f, fx, fy, fxp, fyp, statevar_cu,statevar_cup,controlvar_cu,controlvar_cup] = competitive_eqm;

% sg      = find( statevar_cu == 'epsg_ba1'   );
% ng      = find(controlvar_cu == 'g_cu'      );
% nr      = find(controlvar_cu == 'r_cu'     );
% ni      = find(controlvar_cu == 'iv_cu'    );
% nc      = find(controlvar_cu == 'c_cu'     );
% npi     = find(controlvar_cu == 'pai_cu'   );
% nw      = find(controlvar_cu == 'w_cu'     );
% nh      = find(controlvar_cu == 'h_cu'     );
% noutput = find(controlvar_cu == 'output_cu');
% ntau    = find(controlvar_cu == 'tau_cu'   );
% sizex = size(fx,2);
% load mean_est.txt
% mean_est = [ 0.512403764492088       0.814972888996860       0.981642296795493...
%   0.914504820622145        15.0685072460644        23.3318987429674...
%   0.648781237608673       0.362069382473182       0.123082973898174...
%   0.619274964623890       0.133487072195834        1.65230911155547...
%   0.967105065111974       3.053589436543163E-003  0.991800252380370...
%   0.891991661470736       3.985725784358731E-002  0.229916703403808...
%   0.998056962107902       0.999553608204833       0.887131620153309...
%   0.813267139262906       2.736929722295799E-002  8.578571027419143E-003...
%   2.683758940759942E-002  2.346453821031846E-002  8.482992181724144E-002...
%   0.886824497273074       3.114778245534908E-003  2.589453478147646E-002];
% [ gx, hx, exitflag ] = deep_run(mean_est, f, fx, fy, fxp, fyp);
% x0 = zeros(sizex,1);
% x0(sg) = mean_est(end-7);
% for j = 1:IRFtime
%     IR(j,:) = x0';
%     x0 = hx*x0;
% end
% gxz = gx( [ng ntau nc ni nh nw npi nr], : );
% gxz( 7:8, : ) = 4*gxz( 7:8, : );
% IRFth = IR*gxz';
% for i = 1:8
%     subplot(4,2,i)
%     plot(t,100*IRFth(:,i))
%     axis tight
% end
% return

IRF = IRFwbands(y,f,fx,fy,fxp,fyp, statevar_cu, controlvar_cu);
save irfs_DH.mat IRF 
%load irfs_DH.mat IRF
%plot(t,IRF(1:IRFtime,3,1)', 'b--', t,IRF(1:IRFtime,3,2),'b',t,IRF(1:IRFtime,3,3),'b--','LineWidth',2)
X=[t,fliplr(t)];                
Y=[100*IRF(:,2,1)',fliplr(100*IRF(:,2,3)')];            
fill(X,Y,'b','LineStyle','--',...
'FaceColor',[0.8 0.8 0.8],...
'EdgeColor','k');                  %#plot filled area
hold on
plot(t,100*IRF(:,2,2),'LineWidth',2,'Color',[0 0.447058826684952 0.74117648601532]);
axis tight
title('\bf Deep Habits')

eval(['rmpath ',path_DH])
rmpath C:\Users\Anna\Dropbox\Research\GOVSP1\DH

disp('ROT')
eval(['addpath ',path_ROT])
addpath C:\Users\Anna\Dropbox\Research\GOVSP1\ROT

subplot(2,3,2)
y = [];
num_theta = 28;
for i = 1:num_theta
    eval(['load x',num2str(i),'_ROT.txt' ])
    eval(['hlp = x', num2str(i), '_ROT;' ])
    y = [y   hlp];
end
[f, fx, fy, fxp, fyp, statevar_cu,statevar_cup,controlvar_cu,controlvar_cup] = competitive_eqm;
IRF = IRFwbands(y,f,fx,fy,fxp,fyp, statevar_cu, controlvar_cu);
save irfs_ROT.mat IRF
%load irfs_ROT.mat IRF
X=[t,fliplr(t)];                
Y=[100*IRF(:,2,1)',fliplr(100*IRF(:,2,3)')];            
fill(X,Y,'b','LineStyle','--',...
'FaceColor',[0.8 0.8 0.8],...
'EdgeColor','k');                  %#plot filled area
hold on
plot(t,100*IRF(:,2,2),'LineWidth',2,'Color',[0 0.447058826684952 0.74117648601532]);
axis tight
title('\bf Rule of Thumb')

rmpath C:\Users\Anna\Dropbox\Research\GOVSP1\ROT
eval(['rmpath ',path_ROT])

disp('PROD')
eval(['addpath ',path_PROD])
addpath C:\Users\Anna\Dropbox\Research\GOVSP1\PROD

subplot(2,3,3)
y = [];
num_theta = 28;
for i = 1:num_theta
    eval(['load x',num2str(i),'_PROD.txt' ])
    eval(['hlp = x', num2str(i), '_PROD;' ])
    y = [y   hlp];
end
[f, fx, fy, fxp, fyp, statevar_cu,statevar_cup,controlvar_cu,controlvar_cup] = competitive_eqm;
IRF = IRFwbands(y,f,fx,fy,fxp,fyp, statevar_cu, controlvar_cu);
save irfs_PROD.mat IRF
%load irfs_PROD.mat IRF
%plot(t,IRF(1:IRFtime,3,1)', 'b--', t,IRF(1:IRFtime,3,2),'b',t,IRF(1:IRFtime,3,3),'b--','LineWidth',2)
X=[t,fliplr(t)];                
Y=[100*IRF(:,2,1)',fliplr(100*IRF(:,2,3)')];            
fill(X,Y,'b','LineStyle','--',...
'FaceColor',[0.8 0.8 0.8],...
'EdgeColor','k');                  %#plot filled area
hold on
plot(t,100*IRF(:,2,2),'LineWidth',2,'Color',[0 0.447058826684952 0.74117648601532]);
axis tight
title('\bf Productive Government')

rmpath C:\Users\Anna\Dropbox\Research\GOVSP1\PROD
eval(['rmpath ',path_PROD])

disp('UTIL')
eval(['addpath ',path_UTIL])
addpath C:\Users\Anna\Dropbox\Research\GOVSP1\UTIL

subplot(2,3,4)
y = [];
num_theta = 29;
for i = 1:num_theta
    eval(['load x',num2str(i),'_UTIL.txt' ])
    eval(['hlp = x', num2str(i), '_UTIL;' ])
    y = [y   hlp];
end
[f, fx, fy, fxp, fyp, statevar_cu,statevar_cup,controlvar_cu,controlvar_cup] = competitive_eqm;
IRF = IRFwbands(y,f,fx,fy,fxp,fyp, statevar_cu, controlvar_cu);
save irfs_UTIL.mat IRF
%load irfs_UTIL.mat IRF
%plot(t,IRF(1:IRFtime,3,1)', 'b--', t,IRF(1:IRFtime,3,2),'b',t,IRF(1:IRFtime,3,3),'b--','LineWidth',2)
X=[t,fliplr(t)];                
Y=[100*IRF(:,2,1)',fliplr(100*IRF(:,2,3)')];            
fill(X,Y,'b','LineStyle','--',...
'FaceColor',[0.8 0.8 0.8],...
'EdgeColor','k');                  %#plot filled area
hold on
plot(t,100*IRF(:,2,2),'LineWidth',2,'Color',[0 0.447058826684952 0.74117648601532]);
axis tight
title('\bf G in U')

eval(['rmpath ',path_UTIL])
rmpath C:\Users\Anna\Dropbox\Research\GOVSP1\UTIL

disp('BL')
subplot(2,3,5)
eval(['addpath ',path_BL])
% addpath C:\Users\Anna\Dropbox\Research\GOVSP1\BL
% 
% y = [];
% num_theta = 27;
% for i = 1:num_theta
%     eval(['load x',num2str(i),'_BL.txt' ])
%     eval(['hlp = x', num2str(i), '_BL;' ])
%     y = [y   hlp];
% end
% [f, fx, fy, fxp, fyp, statevar_cu,statevar_cup,controlvar_cu,controlvar_cup] = competitive_eqm;
% IRF = IRFwbands(y,f,fx,fy,fxp,fyp, statevar_cu, controlvar_cu);
% save irfs_BL.mat IRF

load irfs_BL.mat IRF
X=[t,fliplr(t)];                
Y=[100*IRF(:,2,1)',fliplr(100*IRF(:,2,3)')];            
fill(X,Y,'b','LineStyle','--',...
'FaceColor',[0.8 0.8 0.8],...
'EdgeColor','k');                  %#plot filled area
hold on
plot(t,100*IRF(:,2,2),'LineWidth',2,'Color',[0 0.447058826684952 0.74117648601532]);
axis tight
title('\bf Baseline')

eval(['rmpath ',path_BL])
rmpath C:\Users\Anna\Dropbox\Research\GOVSP1\BL

saveas(gcf,'IRF_consumption.eps')
saveas(gcf,'IRF_consumption.pdf')