clear all
clc
close all

global nvar nlags ncoint 
global para_mask para_fix
global nobs lambda nconst
global Pmean Pstd

restoredefaultpath
%addpath C:\Users\31049308\Dropbox\Research\GOVSP1\MODEL
addpath C:\Users\Anna\Dropbox\Research\GOVSP1\MODEL

rand('state',sum(100*clock))
varspec();
VECM = 0;
format long g
if (1 == 1)
    % data = load_data();
    [YY,XX,ti] = loaddata;
    if (VECM == 0)
        XX = XX(:,ncoint+1:end);
    end
    YY = YY - kron(mean(YY),ones(length(YY),1));%kron(mean(YY),[1;1])
    XX = XX - kron(mean(XX),ones(length(XX),1));
    YYYY = YY'*YY;
    XXYY = XX'*YY;
    XXXX = XX'*XX;
    % 
%     pshape = pshape.*(1-para_mask); % either distr or 0
%     Pmean  = Pmean.*( 1-para_mask) + para_fix.*para_mask;% either pmean or fixes value
%     Pstd   = Pstd.*( 1-para_mask); % either pstdd or zero
% 
%     fid = fopen('mXXXX.txt','w');
%     for i = 1:size(XXXX,1)
%         for j = 1:size(XXXX,1)
%             fprintf(fid,[ num2str(XXXX(j,i),'%10.16f') , '\r\n']);
%         end
%     end
%     fclose(fid);
% 
%     fid = fopen('mYYYY.txt','w');
%     for i = 1:nvar
%         for j = 1:nvar
%             fprintf(fid,[ num2str(YYYY(j,i),'%10.16f') , '\r\n']);
%         end
%     end
%     fclose(fid);
% 
%     fid = fopen('mXXYY.txt','w');
%     for i = 1:nvar
%         for j = 1:size(XXXX,1)
%             fprintf(fid,[ num2str(XXYY(j,i),'%10.16f') , '\r\n']);
%         end
%     end
%     fclose(fid);
end
% load mXXYY_dm0.txt
% load mXXXX_dm0.txt
% load mYYYY_dm0.txt
% 
% XXXX = reshape(mXXXX_dm0,nconst+ncoint+nvar*nlags,nconst+ncoint+nvar*nlags);
% XXYY = reshape(mXXYY_dm0,nconst+ncoint+nvar*nlags,nvar);
% YYYY = reshape(mYYYY_dm0,nvar,nvar);
% clear mXXXX_dm0
% clear mXXYY_dm0
% clear mYYYY_dm0
% 
nobs    = 221;%size(YY,1);
lambdas = 0.3;%33;
lambda = lambdas*nobs;

%load mean_est.txt
%Theta = mean_est';
Theta = Pmean';

[f, fx, fy, fxp, fyp, statevar_cu,statevar_cup,controlvar_cu,controlvar_cup] = competitive_eqm;

loglike = objfcnmh(Theta,YYYY,XXYY,XXXX,f,fx, fy, fxp, fyp,statevar_cu,controlvar_cu)

return
acc   = 0;
count = 0;
% hessian = 1;
% if hessian == 1 
%      hessian_x     = fn_hesscd(Theta,1.e-05,YYYY,XXYY,XXXX,f, fx, fy, fxp, fyp, statevar_cu,controlvar_cu);
%      H0            = -inv(hessian_x);
%      [V,D]         = eig(H0);
%      D             = abs(D);
%      H0            = V*D*V';
%      D             = chol(H0);
% else
%       D = 1;
% end
% save hess.mat D 
% return

load hess.mat D

sig_th = 0.03;
tic;
Niter = 1000000;
for j = 1:Niter
    if rem(j,10000) == 0  
       [ j  loglike acc ]
       Theta
    end
    exitflag = 0;
    while exitflag ~= 1
        newTheta  = Theta + (sig_th*randn(size(Theta)))*D;
        newlogpri = priordeephabits(newTheta);
        while newlogpri == -inf 
            newTheta  = Theta + (sig_th*randn(size(Theta)))*D;%mvnrnd(zeros(1,length(Theta)), variance_normal); 
            newlogpri = priordeephabits(newTheta);
        end
        %[newloglike, exitflag] = kalman(newTheta,data,f, fx, fy, fxp, fyp,statevar_cu,controlvar_cu,statevar_cup,controlvar_cup);
         newloglike = objfcnmh(newTheta,YYYY,XXYY,XXXX,f,fx, fy, fxp, fyp,statevar_cu,controlvar_cu);
    end
        if newloglike==-Inf;
                ratio=0;
        else
                ratio = exp(newloglike + newlogpri - (loglike + logpri));
                count = count + 1;
                if rand <= ratio % we accept with prob ratio
                        loglike = newloglike;
                        logpri  = newlogpri;
                        Theta   = newTheta;
                        acc     = acc + 1; % keeping track of the acceptances
                end
        end
        Theta_s(j,:)   = Theta;
        loglike_s(j,1) = loglike;
        logpri_s(j,1)  = logpri;
end
Theta           = mean(Theta_s,1);
acceptance_rate = acc/Niter*100;

toc
hours=toc/3600